<?php

declare(strict_types=1);

namespace Gls\GlsPoland\AdePlus\Type;

use JsonSerializable;
use Gls\GlsPoland\Soap\Client\Type\RequestInterface;

final class AdePreparingBoxGetConsignIDs implements RequestInterface, JsonSerializable
{
    /**
     * @var string
     */
    private $session;

    /**
     * @var int
     */
    private $id_start;

    public function __construct(string $session, int $id_start)
    {
        $this->session = $session;
        $this->id_start = $id_start;
    }

    public function jsonSerialize(): array
    {
        return [
            'session' => $this->session,
            'id_start' => $this->id_start,
        ];
    }

    public function getSession(): string
    {
        return $this->session;
    }

    public function withSession(string $session): AdePreparingBoxGetConsignIDs
    {
        $new = clone $this;
        $new->session = $session;

        return $new;
    }

    public function getId_start(): int
    {
        return $this->id_start;
    }

    public function withId_start(int $id_start): AdePreparingBoxGetConsignIDs
    {
        $new = clone $this;
        $new->id_start = $id_start;

        return $new;
    }
}
